<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Database Utilities</h1>

		<p>The database utilities class contains methods that help you manage your databases.</p>
	</div>

	<div class="content">
		<h1>Intialising the Class</h1>

		<p>In order for you to use this class your database class must already be loaded since this class relies on
		it.  You can load the class by doing the following.</p>

		<div class="example">
			$this->load->dbutil();
		</div>

		<p>Once this class is initialised you can access it via the <b>$this->dbutil</b> object.</p>

		<div class="example">
			$this->dbutil->some_method();
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->list_databases()</h1>

		<p>This method returns an array of database names.</p>

		<div class="example">
			$dbs = $this->dbutil->list_databases();<br />
			<br />
			foreach ($dbs as $db)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $db;<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->optimise_table('table_name')</h1>

		<p>This method allows you to optimise a table using the table named passed as a parameter.  This method
		returns true or false based on success or failure.  <i>Note</i>: this method is only available for
		MySQL and MySQLi databases.</p>

		<div class="example">
			if ($this->dbutil->optimise_table('table_name'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Optimised that database.';<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->repair_table('table_name')</h1>

		<p>This method allows you to repair a table using a table named passed as a parameter.  This method returns
		true or false based on success or failure.  <i>Note</i>: this method is only available for MySQL and MySQLi
		databases.</p>

		<div class="example">
			if ($this->dbutil->repair_table('table_name'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Repaired the database.';<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->optimise_database()</h1>

		<p>This method allows you to optimise a database that the database class is currently connected to.  This
		method returns an array containing the database status messages or false.  <i>Note</i>: this method is only
		available for MySQL and MySQLi databases.</p>

		<div class="example">
			$result = $this->dbutil->optimise_database();<br />
			<br />
			if ($result !=== false)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;print_r($result);<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->csv_from_result($result)</h1>

		<p>This method allows you to create a CSV file from a query result.  The first parameter is the result object
		from the query.</p>

		<div class="example">
			$this->load->dbutil();<br />
			<br />
			$query = $this->db->query('SELECT * FROM `some_table`');<br />
			<br />
			echo $this->dbutil->csv_from_result($query);
		</div>

		<p>The second and third parameters allow you to set the delimeter and newline characters.  By default tabs
		are used as the delimeter and '\n' as a newline.</p>

		<div class="example">
			$delimeter = ",";<br />
			$newlien = "\r\n";<br />
			<br />
			echo $this->dbutil->csv_from_result($query, $delimeter, $newline);
		</div>

		<p>This method will not write the CSV file for you, only produce the contents of the file.</p>
	</div>

	<div class="content">
		<h1>$this->dbutil->xml_from_result($result)</h1>

		<p>This method allows you to generate an XML file from a query result.  The first parameter is a query result
		object, the second may contain an optional array configuration.</p>

		<div class="example">
			$this->load->dbutil();<br />
			<br />
			$query = $this->db->query('SELECT * FROM `some_table`');<br />
			<br />
			$config = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'root' => 'root',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'element' => 'element',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'newline' => "\n",<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'tab' => "\t"<br />
			);<br />
			<br />
			echo $this->dbutil->xml_from_result($query);
		</div>

		<p>This method will not create the XML file you for, only the contents of the XML file.</p>
	</div>

	<div class="content">
		<h1>$this->dbutil->backup()</h1>

		<p>This method allows you to backup your full database or individual tables.  The backup data can be
		compressed in either zip or gzip format.  This method is only available for MySQL and MySQLi databases.</p>

		<p>Due to the limited execution time and memory available to PHP, backing up a very large database may not
		be possible.</p>

		<div class="example">
			$this->load->dbutil();<br />
			<br />
			$backup =&amp; $this->dbutil->backup();<br />
			<br />
			$this->load->utility('filesystem');<br />
			write_file('/path/to/backups/backup.gz', $backup);<br />
		</div>

		<p>Backup preferences are set by submitting an array of values to the first parameter of the backup method.</p>

		<div class="example">
			$pref = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'tables' => array('table1', 'table2'),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'ignore' => array(),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'format' => 'txt',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filename' => 'backup.sql',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'add_drop' => true,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'add_insert' => true,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'newline' => "\n"<br />
			);<br />
			<br />
			$this->dbutil->backup($pref);
		</div>
	</div>

	<div class="content">
		<h1>Backup Preferences</h1>

		<ul>
			<li>'tables' - default value empty array() - An array of tables you want backed up.</li>
			<li>'ignore' - default value empty array() - An array of tables you don't want backed up.</li>
			<li>'format' - default value gzip - The file format of the backup txt, gzip, or zip.</li>
			<li>'filename' - default value current date/time - The name of the backup file.</li>
			<li>'add_drop' - default value true - Whether to include the drop table statements in your SQL.</li>
			<li>'add_insert' - default value true - Whether to include INSERT statements in your SQL.</li>
			<li>'newline' - default value "\n" - Type of newline to use in your SQL.</li>
		</ul>
	</div>

	<div class="content">
		<h1>$this->dbutil->create_database('db_name')</h1>

		<p>This allows you to create a database as specified in the first parameter.  It will return true or false
		based on its success or failure.</p>

		<div class="example">
			if ($this->dbutil->create_database('some_database'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Database has been created.';<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>$this->dbutil->drop_database('db_name')</h1>

		<p>This allows you to drop a database as specified in the first parameter.  It will return true or false
		based on its success or failure.</p>

		<div class="example">
			if ($this->dbutil->drop_database('some_database'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Database has been dropped.';<br />
			&#125;
		</div>
	</div>

	<div class="content">
		<h1>Creating and Dropping Tables</h1>

		<p>There are several things you may wisth to do when creating tables.  Add fields,
		add keys to the table, alter columns. CarbonPHP provides a mechanism for this.</p>
	</div>

	<div class="content">
		<h1>Adding Fields</h1>

		<p>Fields are created via an associative array.  Within the array you must include a 'type' key
		that relates to the datatype of the field.  For example, INT, VARCHAR, TEXT, etc.
		Many datatypes (for example VARCHAR) also require a 'constraint' key.</p>

		<div class="example">
			$fields = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'users' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'varchar',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'constraint' => '100'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;);<br />
			);<br />
			// will translate to 'users VARCHAR(100)' when the field is added.
		</div>

		<p>Additionally the following key/values can be used:</p>

		<ul>
			<li>unsigned/true: to generate 'UNSIGNED' in the field definition.</li>
			<li>default/value: to generate a default value in the field definition.</li>
			<li>null/true: to generate 'NULL' in the field definition.  Without this, the field will
			default to 'NOT NULL'.</li>
			<li>auto_increment/true: to generate an auto_increment flag on the field.</li>
		</ul>

		<div class="example">
			$fields = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_id' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'INT',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'constraint' => '5',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'unsigned' => true,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'auto_increment' =>true<br />
			&nbsp;&nbsp;&nbsp;&nbsp;),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_title' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'VARCHAR',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'constraint' => '100'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_author' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'VARCHAR',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'constraint' => '100',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'default' => 'BlogOwner'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;)<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_description' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'TEXT',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'null' => true<br />
			&nbsp;&nbsp;&nbsp;&nbsp;)<br />
			);
		</div>

		<p>After the fields have been defined, they can be added using <b>$this->dbutils->add_fields($fields);</b>
		followed by a call to the <b>create_table()</b> method.</p>

		<h1>$this->dbutils->add_field()</h1>

		<p>The add fields method will accept the above array.</p>

		<h1>Passing Strings as Fields</h1>

		<p>If you know exactly how you want a field to be created, you can pass the string into
		the field definitions with <b>add_field()</b>.</p>

		<div class="example">
			$this->dbutils->add_field("label varchar(100) NOT NULL DEFAULT 'default label'");
		</div>

		<p><i>Note:</i> multiple calls to <b>add_field()</b> are cumulative.</p>

		<h1>Creating an ID Field</h1>

		<p>There is a special exception for creating ID fields.  A field with type id will automatically be
		assignment as an INT(9) auto_incrementing primary key.</p>

		<div class="example">
			$this->dbutils->add_field('id');
			// creates id INT(9) NOT NULL AUTO_INCREMENT
		</div>

		<h1>Adding Keys</h1>

		<p>Generally speaking, you'll want your table to have keys.  This is accomplished with <b>
		$this->dbutils->add_key('field')</b>.  An optional parameter set to <b>true</b> will make it
		a primary key.  Note that <b>add_key()</b> must be followed by a call to <b>create_table()</b>.</p>

		<div class="example">
			$this->dbutils->add_key('blog_id', true);<br />
			// gives PRIMARY KEY (blog_id)<br />
			<br />
			$this->dbutils->add_key('blog_name');<br />
			// gives KEY (blog_name)
		</div>

		<h1>Creating a Table</h1>

		<p>After fields and keys have been declared, you can create a new table with</p>

		<div class="example">
			$this->dbutils->create_table('table_name');<br />
			// gives CREATE TABLE table_name;
		</div>

		<p>An optional second parameter set to <b>true</b> adds an 'IF NOT EXISTS' clause into the definition.</p>

		<div class="example">
			$this->dbutil->create_table('table_name', true);<br />
			// give CREATES TABLE IF NOT EXISTS table_name
		</div>

		<h1>Dropping a Table</h1>

		<p>Executes a DROP TABLE SQL query.</p>

		<div class="example">
			$this->dbutil->drop_table('table_name');<br />
			// gives DROP TABLE IF EXISTS table_name
		</div>
	</div>

	<div class="content">
		<h1>Modifying Tables</h1>

		<h1>$this->dbutils->add_column()</h1>

		<p>The <b>add_column()</b> method is used to modify an existing table.  It accepts the same field
		array as above, and can be used for an unlimited number of additional fields.</p>

		<div class="example">
			$fields = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'preferences' => array('type' => 'TEXT')<br />
			);<br />
			$this->dbutils->add_column('table_name', $fields);<br />
			// gives ALTER TABLE table_name ADD preferences TEXT
		</div>

		<h1>$this->dbutils->drop_column()</h1>

		<p>Used to remove a column from a table.</p>

		<div class="example">
			$this->dbutil->drop_column('table_name', 'column_to_drop');
		</div>

		<h1>$this->dbutils->modify_column()</h1>

		<p>The usage of the method is identifcal to <b>add_column()</b> except it alters an existing column rather
		than adding a new one.  In order to use it you must add a 'name' key into the field defining array.</p>

		<div class="example">
			$fields = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'old_name' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'name' => 'new_name',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'type' => 'TEXT'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;)<br />
			);<br />
			$this->dbutil->modify_column('table_name', $fields);<br />
			// gives ALTER TABLE table_name CHANGE old_name new_name TEXT
		</div>
	</div>
</body>

</html>
